#include <GL/glut.h>
#include <stdio.h>
#include "Triangle.h"
void Mesh::Draw()
{
	vector<Triangle>::iterator i;
	glEnable(GL_LIGHTING);
	glEnable(GL_NORMALIZE);
	glBegin(GL_TRIANGLES);
	//glBegin(GL_LINE_STRIP);
	for(i=T.begin();i!=T.end();++i)
	{
		glNormal((*i).N);
		glVertex((*i).v[0]);
		glVertex((*i).v[1]);
		glVertex((*i).v[2]);
	}
	glEnd();
}

void Mesh::Open(char *filename)
{
	FILE *fp;
	fp=fopen(filename,"r");
	Triangle tt;
	T.clear();
	float xf,yf,zf;
	int nc;
	while(1)
	{
		nc=fscanf(fp,"%f %f %f",&xf,&yf,&zf);
		if(nc!=3) break;
		tt.v[0]=Point3f(xf,yf,zf);
		nc=fscanf(fp,"%f %f %f",&xf,&yf,&zf);
		if(nc!=3) break;
		tt.v[1]=Point3f(xf,yf,zf);
		nc=fscanf(fp,"%f %f %f",&xf,&yf,&zf);
		if(nc!=3) break;
		tt.v[2]=Point3f(xf,yf,zf);
		tt.CalcNormal();
		T.push_back(tt);
	}
	fclose(fp);
	printf("Read %i triangles",T.size());
}

void Triangle::CalcNormal()
{
	N=(v[1]-v[0])^(v[2]-v[0]);
	N.Normalize();
}
